//+------------------------------------------------------------------+
//|                                                                  |
//|                   Copyright 2000-2014, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#include "stdafx.h"

//---
#define MAX_SIZE 5750
//---
#define IM 139968
#define IA 3877
#define IC 29573
//---
double nums[MAX_SIZE];

//+------------------------------------------------------------------+
//| Функция тестирования                                             |
//+------------------------------------------------------------------+
double TestRandom(double max)
  {
   static long last=42;
//---
   last=(last*IA+IC)%IM;
   return(max*last/IM);
  }
//+------------------------------------------------------------------+
//| Функция тестирования                                             |
//+------------------------------------------------------------------+
void TestMomentsX()
  {
   int i,mid=0;
   double sum=0.0;
   double mean=0.0;
   double average_deviation=0.0;
   double standard_deviation=0.0;
   double variance=0.0;
   double skew=0.0;
   double kurtosis=0.0;
   double median=0.0;
   double deviation=0.0;
   int array_size=4096;
//---
   mean=sum/MAX_SIZE;
   for(i=0; i<MAX_SIZE; i++)
     {
      deviation=nums[i]-mean;
      average_deviation+=abs(deviation);
      variance+=pow(deviation,2);
      skew+=pow(deviation,3);
      kurtosis+=pow(deviation,4);
     }
   average_deviation/=MAX_SIZE;
   variance/=(MAX_SIZE-1);
   standard_deviation=sqrt(variance);
   if(variance)
     {
      skew/=(MAX_SIZE*variance*standard_deviation);
      kurtosis=(kurtosis/(MAX_SIZE*variance*variance))-3.0;
     }
   mid=(MAX_SIZE/2);
   median=(MAX_SIZE%2)?nums[mid]:(nums[mid]+nums[mid-1])/2;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
DWORD TestMoments()
  {
   int   i;
   DWORD tick_count,res;
//--- тест
   for(i=0;i<MAX_SIZE;i++)
      nums[i]=TestRandom(1000000.0);
   tick_count=GetTickCount();
   for(i=0;i<MAX_SIZE;i++)
      TestMomentsX();
   res=GetTickCount()-tick_count;
//--- возвращает время, затраченное на выполнение теста, в милисекундах
   return(res);
  }
//+------------------------------------------------------------------+
